#include "sdkconfig.h"
#include "soc/rtc_cntl_reg.h"
#include "soc/rtc_io_reg.h"
#include "soc/soc_ulp.h"
#include "soc/sens_reg.h"

.macro push rx
	st \rx,r3,0
	sub r3,r3,1
.endm

.macro pop rx
	add r3,r3,1
	ld \rx,r3,0
.endm

.macro psr sr=r1 pos=.
	.set _next2,(\pos+16)
	move \sr,_next2
	push \sr
.endm

.macro ret sr=r1
	pop \sr
	jump \sr
.endm

.macro GPIO_LOW
	WRITE_RTC_REG(RTC_GPIO_OUT_W1TC_REG, RTC_GPIO_OUT_DATA_W1TC_S + 10, 1, 1)
.endm

/* Output mode */
.macro GPIO_HIGH
	WRITE_RTC_REG(RTC_GPIO_OUT_W1TS_REG, RTC_GPIO_OUT_DATA_W1TS_S + 10, 1, 1)
.endm

	.bss

	.global stack
stack:
	.skip 24

	.global stackEnd
stackEnd:
	.long 0

	.text
	.global entry
entry:
	move r3, stackEnd

	//delay(11 sec)
	move r0, 1000
	psr
	jump delay_ms

	GPIO_LOW

	//delay(1 sec)
	move r0, 1000
	psr
	jump delay_ms

	GPIO_HIGH

		//delay(4 sec)
	move r0, 4000
	psr
	jump delay_ms

	jump wake_up
	/* End program */

	//delay
delay_ms:
	delay_ms_loop:
	sub r0, r0, 1
	wait(7990) /* 1millsecond = 1000 microsecond */
	jumpr delay_ms_loop, 1, GE
	ret
